import '../lib/teamspeak.dart';
import "dart:async";

/*
 * This test moves a client with the userid 3 to the channel where most clients
 * are currently in.
 */

// User login data - needs to be filled in in order to use the test
final String teamspeak_host = "###";
final int teamspeak_serverquery_port = 10011;
final String client_username = "###";
final String client_password = "###";

final int client_database_id = 3; 

void main(){  
    final server = new Server(teamspeak_host,
        username: client_username,
        password: client_password, 
        enableThrottling: false,
        autoUpdate: new Duration(seconds: 1));

    server
        .connect()
        .then((Server serv){
          serv.onUpdate.forEach((DateTime updateTime){
            // Get peter pan channel
            final int oldPanChannel = serv.users[client_database_id].cid;
            // Count users in channels
            final Map<int, int> usersInChannels = new Map();
            int topUsers = 0; Channel topUsersChannel;
            serv.channels.forEach((int id, Channel c){
              usersInChannels[id] = c.users.
                  where((usr) => !usr.is_serverquery_client && usr.database_id != 3).length;
              if(usersInChannels[id] > topUsers){
                topUsers = usersInChannels[id];
                topUsersChannel = c;
              }
            });
            if(topUsersChannel != null && topUsersChannel.id != oldPanChannel){
              print("Move him from ${serv.users[client_database_id].channel.name} to ${topUsersChannel.name}!");
              serv.users[3].move(topUsersChannel).catchError((e) => null);
            }
          });
        });
}